Package org.gradle.api.provider

# Interface Provider<T>

Type Parameters:
  `T` - Type of value represented by provider

All Known Subinterfaces:
  `DirectoryProperty`, `DirectoryVar`, `ListProperty<T>`, `NamedDomainObjectProvider<T>`, `Property<T>`, `PropertyState<T>`, `RegularFileProperty`, `RegularFileVar`, `TaskProvider<T>`

@Incubating public interface Provider<T>
A container object that provides a value of a specific type. The value can be retrieved by the method `get()` or `getOrNull()`.

A provider may not always have a value available, for example when the value may not yet be known but will be known at some point in the future. When a value is not available, `isPresent()` returns `false` and retrieving the value will fail with an exception.

A provider may not always provide the same value. Although there are no methods on this interface to change the value, the provider implementation may be mutable or use values from some changing source.

A provider may provide a value that is mutable and that changes over time.

A typical use of a provider is to pass values from one DSL element to another, e.g. from an extension to a task. Providers also allow expensive computations to be deferred until their value is actually needed, usually at task execution time.

For a provider whose value can be mutated, see `PropertyState`.

Do not use `Provider<File>`. Use `Directory` or `RegularFile` instead.

Note: This interface is not intended for implementation by build script or plugin authors. An instance of this class can be created through the factory methods `Project.provider(java.util.concurrent.Callable)` or `ProviderFactory.provider(java.util.concurrent.Callable)`.

Since:
  4.0

## Method Summary

Modifier and Type
Method
Description
`T`
`get()`
Returns the value of this provider if it has a value present, otherwise throws `java.lang.IllegalStateException`.
`T`
`getOrElse(T defaultValue)`
Returns the value of this provider if it has a value present.
`T`
`getOrNull()`
Returns the value of this provider if it has a value present.
`boolean`
`isPresent()`
Returns `true` if there is a value present, otherwise `false`.
`<S> Provider<S>`
`map(Transformer<? extends S,? super T> transformer)`
Returns a new `Provider` whose value is the value of this provider transformed using the given function.

## Method Details

### get

T get()
Returns the value of this provider if it has a value present, otherwise throws `java.lang.IllegalStateException`.

Returns:
  the current value of this provider.
Throws:
  `IllegalStateException` - if there is no value present

### getOrNull

@Nullable @Internal T getOrNull()
Returns the value of this provider if it has a value present. Returns `null` a value is not available.

Returns:
  the value or `null`

### getOrElse

T getOrElse(T defaultValue)
Returns the value of this provider if it has a value present. Returns the given default value if a value is not available.

Returns:
  the value or the default value.
Since:
  4.3

### map

<S> Provider<S> map(Transformer<? extends S,? super T> transformer)
Returns a new `Provider` whose value is the value of this provider transformed using the given function.

The new provider will be live, so that each time it is queried, it queries this provider and applies the transformation to the result. Whenever this provider has no value, the new provider will also have no value.

Note that the new provider may cache the result of the transformations and so there is no guarantee that the transformer is called on every query of the new provider. The new provider will apply the transformation lazily, and calculate the value for the new provider when queried.

Parameters:
  `transformer` - The transformer to apply to values. Should not return `null`.
Since:
  4.3

### isPresent

@Internal boolean isPresent()
Returns `true` if there is a value present, otherwise `false`.

Returns:
  `true` if there is a value present, otherwise `false`